#! /bin/sh
# Copyright (c) 1995-2000 SuSE Linux AG Nuernberg, Germany.
#
# Author: Peter Poeml <poeml@suse.de>, 2001
#
# /etc/init.d/ddt-client
#   and its symbolic link
# /usr/sbin/rcddt-client
#
# System startup script for the Dynamic DNS Tools Client Daemon (ddtcd)
#
### BEGIN INIT INFO
# Provides:			ddt-client
# Required-Start:		$local_fs $remote_fs $network 
# X-UnitedLinux-Should-Start:	$named $syslog $time
# Required-Stop:
# X-UnitedLinux-Should-Stop:
# Default-Start:		3 5
# Default-Stop:			0 1 2 6
# Short-Description:		DDT client daemon 
# Description:			Start the DDT (Dynamic DNS Tools) client daemon
# 				that can register the current IP address under
# 				a DNS domain name at a DDT server. The actual
# 				registering is triggered by calling 'ddtc
# 				--online', though.
### END INIT INFO

DAEMON="DDT client daemon"
DAEMON_BIN=/usr/sbin/ddtcd
DAEMON_CONF=/etc/ddtcd.conf
DAEMON_PIDFILE=/var/run/ddt/ddtcd.pid
STARTPROC_LOGFILE=/var/log/rc.ddt-client.log
SUPPORTS_HUP="no"

test -x $DAEMON_BIN || exit 5

# Shell functions sourced from /etc/rc.status:
#      rc_check         check and set local and overall rc status
#      rc_status        check and set local and overall rc status
#      rc_status -v     ditto but be verbose in local rc status
#      rc_status -v -r  ditto and clear the local rc status
#      rc_failed        set local and overall rc status to failed
#      rc_failed <num>  set local and overall rc status to <num><num>
#      rc_reset         clear local rc status (overall remains)
#      rc_exit          exit appropriate to overall rc status
. /etc/rc.status

# First reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0 - success
# 1 - generic or unspecified error
# 2 - invalid or excess argument(s)
# 3 - unimplemented feature (e.g. "reload")
# 4 - insufficient privilege
# 5 - program is not installed
# 6 - program is not configured
# 7 - program is not running
# 
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signalling is not supported) are
# considered a success.

case "$1" in
    start)
	echo -n "Starting $DAEMON"
	## Start daemon with startproc(8). If this fails
	## the echo return value is set appropriate.

	## If there is no conf file, skip starting of ddtcd
	## and return with "program not configured"
	if ! [ -f $DAEMON_CONF ]; then
		echo -e -n "... no configuration file found";
		# Tell the user this has skipped
		rc_status -s
		# service is not configured
		exit 6;
	fi

	# startproc should return 0, even if service is 
	# already running to match LSB spec.
	rm -f $STARTPROC_LOGFILE
	startproc -l $STARTPROC_LOGFILE $DAEMON_BIN 
	rc=$?

	if ! [ $rc -eq 0 ]; then
		if [ $link = $base ] ; then
			## be quiet
			cat $STARTPROC_LOGFILE
		else
			## be verbose
			echo -e -n "  please see $STARTPROC_LOGFILE for details ";
		fi
		## set status to failed
		rc_failed
	fi

	# Remember status and be verbose
	rc_status -v
	;;
    stop)
	echo -n "Shutting down $DAEMON"
	## Stop daemon with killproc(8) and if this fails
	## set echo the echo return value.

	killproc -p $DAEMON_PIDFILE -TERM $DAEMON_BIN

	# Remember status and be verbose
	rc_status -v
	;;
    try-restart)
	## Stop the service and if this succeeds (i.e. the 
	## service was running before), start it again.
	$0 status >/dev/null && $0 restart

	# Remember status and be quiet
	rc_status
	;;
    restart)
	## Stop the service and regardless of whether it was
	## running or not, start it again.
	$0 stop
	$0 start

	# Remember status and be quiet
	rc_status
	;;
    force-reload)
	## Signal the daemon to reload its config. Most daemons
	## do this on signal 1 (SIGHUP).
	## If it does not support it, restart.

	echo -n "Reload service $DAEMON"

	if [ "$SUPPORTS_HUP" = "yes" ]; then 
		killproc -p $DAEMON_PIDFILE -HUP $DAEMON_BIN
		#touch $DAEMON_PIDFILE
		rc_status -v
	else
		$0 stop  &&  $0 start
		rc_status 
	fi
	;;
    reload)
	## Like force-reload, but if daemon does not support
	## signalling, do nothing (!)

	if [ "$SUPPORTS_HUP" = "yes" ]; then
		# If it supports signalling:
		echo -n "Reload service $DAEMON"
		killproc -p $DAEMON_PIDFILE -HUP $DAEMON_BIN
		#touch $DAEMON_PIDFILE
		rc_status -v1
	else
		## Otherwise if it does not support reload:
		rc_failed 3
		rc_status -v1
	fi
	;;
    status)
	echo -n "Checking for $DAEMON: "
	## Check status with checkproc(8), if process is running
	## checkproc will return with exit status 0.

	# Status has a slightly different for the status command:
	# 0 - service running
	# 1 - service dead, but /var/run/  pid  file exists
	# 2 - service dead, but /var/lock/ lock file exists
	# 3 - service not running

	# NOTE: checkproc returns LSB compliant status values.
	checkproc -p $DAEMON_PIDFILE $DAEMON_BIN
	rc_status -v
	;;
    probe)
	## Optional: Probe for the necessity of a reload,
	## give out the argument which is required for a reload.

	if [ "$DAEMON_CONF" -nt "$DAEMON_PIDFILE" ]; then 
		if [ "$SUPPORTS_HUP" = "yes" ]; then 
			echo reload
		else 
			echo restart
		fi
	fi
	;;
    *)
	echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload|probe}"
	exit 1
	;;
esac
rc_exit
